unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, GSpreader, Grids, GStandContr, Gbase, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    Gbase1: TGbase;
    GGrid1: TGGrid;
    Gbase2: TGbase;
    GSpreader1: TGSpreader;
    GSpreader2: TGSpreader;
    GGrid2: TGGrid;
    add1: TSpeedButton;
    delete1: TSpeedButton;
    add2: TSpeedButton;
    delete2: TSpeedButton;
    ComboBox1: TComboBox;
    Label1: TLabel;
    balance: TSpeedButton;
    Label2: TLabel;
    GTool1: TGTool;
    pack: TSpeedButton;
    report: TRichEdit;
    all2: TSpeedButton;
    GLabel1: TGLabel;
    showreport: TSpeedButton;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Gbase1Positioning(Sender: TObject; NewRecNo: Cardinal);
    procedure Gbase2Positioning(Sender: TObject; NewRecNo: Cardinal);
    procedure ComboBox1Change(Sender: TObject);
    procedure add1Click(Sender: TObject);
    procedure delete1Click(Sender: TObject);
    procedure add2Click(Sender: TObject);
    procedure GGrid1Click(Sender: TObject);
    procedure delete2Click(Sender: TObject);
    procedure balanceClick(Sender: TObject);
    procedure packClick(Sender: TObject);
    procedure AddToReport(value: string);
    procedure all2Click(Sender: TObject);
    procedure Gbase1BeforeOpen(Sender: TObject);
    procedure Gbase2BeforeOpen(Sender: TObject);
    function Estimate(value: string): Currency;
    procedure showreportClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Gbase1BeforeOpen(Sender: TObject);
begin
  ggrid1.SetColumnsOrder([0,1],true);
  ggrid1.SetColumnsSize([50,130]);
  gspreader1.AddStdReceivers([],[],[ggrid1],[]);
end;

procedure TForm1.Gbase2BeforeOpen(Sender: TObject);
begin
  ggrid2.SetColumnsOrder([1,2,3],true);
  ggrid2.SetColumnsSize([200,80,80]);
  gspreader2.AddStdReceivers([],[glabel1],[ggrid2],[]);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  shortdateformat:='dd.mm.yyyy';
  dateseparator:='.';
  gbase1.Open('Name');
  gbase2.Open('Date');
  ggrid1.Click;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  gbase1.Close;
  gbase2.Close;
end;

procedure TForm1.Gbase1Positioning(Sender: TObject;
  NewRecNo: Cardinal);
begin
  gspreader1.Spread(NewRecNo);
end;

procedure TForm1.Gbase2Positioning(Sender: TObject;
  NewRecNo: Cardinal);
begin
  gspreader2.Spread(NewRecNo);
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  report.visible:=false;
  if combobox1.Text = 'All' then
    gbase1.SetFilter([])
  else
    gbase1.SetFilter([' Type = '+combobox1.Text]);
  ggrid1.Click;
end;

procedure TForm1.add1Click(Sender: TObject);
var sType: string[10];
begin
  sType:=combobox1.Text;
  if sType='All' then
    exit;
  gbase1.SetFilter([]);
  gbase1.Append;
  gbase1.Write('Type',@sType);
  gbase1.SetFilter([]);
  gbase1.SetFilter([' Type = '+combobox1.Text]);
end;

procedure TForm1.delete1Click(Sender: TObject);
begin
  gbase1.Delete;
  gbase1.SetFilter([]);
  gbase1.SetFilter([' Type = '+combobox1.Text]);
end;

procedure TForm1.add2Click(Sender: TObject);
var sName: string[30];
    sDate: TDate;
begin
  sDate:=now;
  ggrid2.Visible:=false;
  gbase2.setFilter([]);
  gbase2.Append;
  gbase1.Read('Name',@sName);
  gbase2.Write('Id',@sName);
  gbase2.Write('Date',@sDate);
  gbase2.SetFilter([' Id = '+sName]);
  ggrid2.Visible:=true;
  gbase2.Last;
end;

procedure TForm1.delete2Click(Sender: TObject);
var sName: string[30];
begin
  gbase1.Read('Name',@sName);
  gbase2.Delete;
  gbase2.SetFilter([]);
  gbase2.SetFilter([' Id = '+sName]);
end;

procedure TForm1.GGrid1Click(Sender: TObject);
var sName: string[30];
    v, thesum: Currency;
begin
  thesum:=0.00;
  gbase1.Read('Name',@sName);
  gbase2.SetFilter([' Id = '+sName]);
  if gbase2.Filtered then
  begin
    gbase2.First;
    while not gbase2.Eof do
    begin
      if gbase2.Read('Value',@v) then
	thesum:=thesum+v;
      gbase2.Next;
    end;
    ggrid2.Visible:=true
  end
  else
    ggrid2.Visible:=false;
  label1.Caption:='Sume: '+FormatFloat('0.00',thesum);
  label1.Repaint;
end;

procedure TForm1.balanceClick(Sender: TObject);
begin
  label2.Caption:=' Incomes:   '+FormatFloat('0.00',Estimate('Incomes'))+#13
                 +' Expenses:  '+FormatFloat('0.00',Estimate('Expenses'))+#13
                 +' Debt:      '+FormatFloat('0.00',Estimate('Debt'));
end;

function TForm1.Estimate(value: string): currency;
var i, j: integer;
    sName: string[30];
    v: currency;
begin
  result:=0.00;
  gbase1.SetFilter([' Type = '+value]);
  if gbase1.Filtered then
  begin
    for i:=1 to gbase1.recordcount do
    begin
      gbase1.AliasRecNo:=i;
      if gbase1.Read('Name',@sName) then
      begin
        gbase2.SetFilter([' type = '+sName]);
        if gbase2.Filtered then
        begin
          for j:=1 to gbase2.RecordCount do
          begin
            gbase2.AliasRecNo:=j;
            if gbase2.Read('Value',@v) then
              result:=result+v;
          end; // for j
        end; //if gbase2.filtered
      end;// if read
    end;// for i
  end;
end;

procedure TForm1.packClick(Sender: TObject);
begin
  gbase1.Close;
  gtool1.CopyAndPack(form1,'money1','temp',true);
  gbase1.Open('Name');
  gbase2.Close;
  gtool1.CopyAndPack(form1,'money2','temp',true);
  gbase2.Open('Date');
end;

procedure TForm1.AddToReport(value: string);
var i: integer;
    sName: string[30];
    s: string[100];
    v: currency;
begin
  gbase1.SetFilter([' Type = '+value]);
  if gbase1.Filtered then
  begin
    report.SelAttributes.Size:=12;
    report.SelAttributes.Style:=[fsbold,fsunderline];
    report.Lines.Add(value);
    for i:=1 to gbase1.recordcount do
    begin
      gbase1.AliasRecNo:=i;
      if gbase1.Read('Name',@sName) then
      begin
        gbase2.SetFilter([' Id = '+sName]);
        if gbase2.Filtered then
        begin
          report.SelAttributes.Size:=10;
          report.SelAttributes.Style:=[fsbold];
          report.Lines.Add('    '+sName);
          report.SelAttributes.Size:=8;
          report.SelAttributes.Style:=[];
          gbase2.First;
          while not gbase2.Eof do
          begin
            if (gbase2.Read('Name',@s)) and (gbase2.Read('Value',@v)) then
              report.Lines.Add('         '+s+' = '+formatfloat('0.00',v));
            gbase2.Next;
          end;
        end;//if gbase2.filtered
      end;//if read
    end;//for i
  end;
end;

procedure TForm1.all2Click(Sender: TObject);
begin
  gbase2.SetFilter([]);
  ggrid2.Click;
end;

procedure TForm1.showreportClick(Sender: TObject);
begin
  if showreport.Down then
  begin
    report.Clear;
    report.Visible:=true;
    report.BringToFront;
    AddToReport('Incomes');
    AddToReport('Expenses');
    AddToReport('Debt');
  end
  else
    report.Visible:=false;
end;

end.
